/*
Copyright (c) 2008 Institute of Computing Technology of Chinese Academy of Sciences, Science and Technology Facilities Council, and Xlab d.o.o.
All rights reserved.

This file is part of VOM. VOM is part of XtreemOS, a Linux-based Grid Operating System, see <http://www.xtreemos.eu> for more details. The XtreemOS project has been developed with the financial support of the European Commission's IST program under contract #FP6-033576.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the XtreemOS project nor the names of its partners and/or contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
Ext.app.SearchField = Ext.extend(Ext.form.TwinTriggerField, {
    initComponent: function(){
        Ext.app.SearchField.superclass.initComponent.call(this);
        this.on('specialkey', function(f, e){
            if (e.getKey() == e.ENTER) {
                this.onTrigger2Click();
            }
        }, this);
    },
    
    validationEvent: false,
    validateOnBlur: false,
    trigger1Class: 'x-form-clear-trigger',
    trigger2Class: 'x-form-search-trigger',
    hideTrigger1: true,
    width: 180,
    hasSearch: false,
    paramName: 'query',
    
    onTrigger1Click: function(){
        if (this.hasSearch) {
            this.el.dom.value = '';
            var o = {
                start: 0
            };
            this.store.baseParams = this.store.baseParams ||
            {};
            this.store.baseParams[this.paramName] = '';
            this.store.reload({
                params: o
            });
            this.triggers[0].hide();
            this.hasSearch = false;
        }
    },
    
    onTrigger2Click: function(){
        var v = this.getRawValue();
        if (v.length < 1) {
            this.onTrigger1Click();
            return;
        }
        var o = {
            start: 0
        };
        this.store.baseParams = this.store.baseParams ||
        {};
        this.store.baseParams[this.paramName] = v;
        this.store.reload({
            params: o
        });
        this.hasSearch = true;
        this.triggers[0].show();
    }
});

var addNewResource = function(store){
    var winId = "addNewResource";
    
    var myWin = Ext.getCmp(winId);
    if (myWin != null) {
        myWin.show();
        return;
    }
    
    function checkSubmited(){
        var name = Ext.getCmp('voname');
        if (!name.el.dom.value == null || name.el.dom.value.length <= 0) {
            Ext.MessageBox.alert("Create A VO", "vo name is null");
            name.focus();
            return false;
        }
        
        return true;
    }
    
	 var store1 = new Ext.data.JsonStore({
        url: "../model/list_rcas.jsp",
        totalProperty: "results",
        root: "rows",
		id: "id",
        fields: ['id','myDesc','name']
    });
	
	 var fld_width = 200;
	var fld_height = 300;
    var fs = new Ext.FormPanel({
        labelWidth: 70,
        bodyStyle: 'padding:15px',
        border: false,
        frame: true,
        waitMsgTarget: true,
        url: '../model/res_util.jsp?func=add',
        layout: 'fit',
        items: [{
            layout: 'column',
            items: [{
                columnWidth: .9,
                layout: 'form',
			items:[{
                xtype: 'textfield',
                fieldLabel: 'Name',
                name: 'resname',
                id: 'resname',
				 allowBlank: false,
                anchor: '95%'
            },{
                xtype: 'textfield',
                fieldLabel: 'Desc',
                name: 'desc',
                id: 'desc',
				 allowBlank: false,
                anchor: '95%'
            },new Ext.form.ComboBox({
                store: store1,
                displayField: 'myDesc',
				valueField: 'id',
                typeAhead: true,
                mode: 'local',
                id: 'rca',
                name: 'rca',
                triggerAction: 'all',
                emptyText: 'Select a RCA...',
                selectOnFocus: true,
                fieldLabel: 'RCA',
                width: fld_width
                // applyTo: 'local-states'
            }),/*{
                xtype: 'textfield',
                fieldLabel: 'RCA',
                name: 'rca',
                id: 'rca',
				anchor: '95%'
            }, */{
                xtype: 'textfield',
                fieldLabel: 'Host',
                name: 'host',
                id: 'host',
				allowBlank: false,
                anchor: '95%'
            }, {
                xtype: 'textfield',
                fieldLabel: 'Port',
                name: 'port',
                id: 'port',
				allowBlank: false,
                anchor: '95%'
            },{
                xtype: 'textfield',
                fieldLabel: 'Port',
                name: 'port',
                id: 'port',
				allowBlank: false,
                anchor: '95%'
            },{
                xtype: 'textfield',
                fieldLabel: 'Arch',
                name: 'arch',
                id: 'arch',
				allowBlank: false,
                anchor: '95%'
            },{
                xtype: 'textfield',
                fieldLabel: 'OS',
                name: 'os',
                id: 'os',
				allowBlank: false,
                anchor: '95%'
            },{
                xtype: 'textfield',
                fieldLabel: 'CPUs',
                name: 'cpus',
                id: 'cpus',
				allowBlank: false,
                anchor: '95%'
            },{
                xtype: 'textfield',
                fieldLabel: 'RAM(MB)',
                name: 'ram',
                id: 'ram',
				allowBlank: false,
                anchor: '95%'
            }, {
                xtype: 'textfield',
                fieldLabel: 'Speed(MHz)',
                name: 'speed',
                id: 'speed',
                anchor: '95%'
            }]
			}]
        }],
        
        buttons: [{
            text: 'Create',
            handler: function(){
                var form = fs.getForm();
                var resname = Ext.getCmp('resname').el.dom.value;
                var node_id = Ext.getCmp('rca');
				node_id.el.dom.value= node_id.value;
				
                form.submit({
                    waitTitle: 'Connecting',
                    waitMsg: 'Waiting...',
                    success: function(form, action){
                        Ext.Msg.alert('Create a Resource', "Successfully create a Resource:!" + resname);
                        form.reset();
						myWin.close();
						if(store)
							store.load();
                    },
                    failure: function(form, action){
                        if (action.failureType == 'server') {
                            obj = Ext.util.JSON.decode(action.response.responseText);
                            Ext.Msg.alert('Server Failed!', obj.errors.reason);
                        }
                        else {
                            Ext.Msg.alert('Warning!', 'Server is unreachable:' + action.response.responseText);
                        }
                    }
                });
            }
        }, {
            text: 'Cancel',
            handler: function(){
                myWin.close();
            }
        }]
    });
    
    myWin = new Ext.Window({
        id: winId,
        width: 500,
        height: 360,

        plain: true,
        title: 'RCA Creation',
        layout: 'fit',
        border: false,
        closeAction: 'hide',
        closable: true,
        items: fs,
        rendTo: 'form-ct'
    });
    myWin.show(this);
	
	store1.load();
    
};
Ext.onReady(function(){
    Ext.QuickTips.init();
    
    var store = new Ext.data.JsonStore({
        url: "../model/list_res.jsp",
        totalProperty: "results",
        root: "rows",
        id: "id",
        fields: ['id', 'name', 'desc','rca','vos']
    });
    var grid = new Ext.grid.GridPanel({
        store: store,
        loadMask: true,
		id:'rcagrid',
		border:false,
        columns: [new Ext.grid.CheckboxSelectionModel(), {
            header: "Id",
            width: 30,
            sortable: true,
            dataIndex: 'id'
        }, {
            header: "Name",
            width: 60,
            sortable: true,
            dataIndex: 'name'
        }, {
            header: "RCA",
            width: 80,
            sortable: true,
            dataIndex: 'rca'
        }, {
            header: "VOs",
            width: 80,
            sortable: true,
            dataIndex: 'vos'
        },{
            header: "Desc",
            width: 300,
            sortable: true,
            dataIndex: 'desc'
        }],
        viewConfig: {
            forceFit: true
        },
        sm: new Ext.grid.RowSelectionModel({
            singleSelect: true
        }),
        width: 600,
        height: 200,
        frame: true,
        tbar: ['Search: ', ' ', new Ext.app.SearchField({
            store: store,
            width: 320
        }),{
            text: 'AddResource',
            tooltip: 'Add a new Resource',
            handler: function(){
                addNewResource(store);
            }
        }, {
            text: 'DelResource',
            tooltip: 'Delete a Resource',
            //iconCls:'add',
            handler: function(){
                var _record = grid.getSelectionModel().getSelected();
                if (!_record) {
                    Ext.Msg.alert('Warning!', 'Please select a resource before deleting it');
                    return;
                }
                Ext.Ajax.request({
                    url: 'deleteRCA.jsp?rcaid=',
                    success: function(responseObject){
                        store.remove(_record);
                        //loadFile(responseObject.responseText);
                    },
                    failure: function(responseObject){
                        Ext.Msg.alert('Warning!', 'Failed to delete a rca:' + responseObject);
                    }
                });
            }
        },{
            text: 'Refresh',
            tooltip: 'Refresh',
            handler: function(){
                store.load();
                //grid.render();
            }
        }]
        //iconCls: 'icon-grid'
    });
	
	var vostore = new Ext.data.JsonStore({
        url: "../model/list_vo.jsp?all=true",
        totalProperty: "results",
        root: "rows",
        id: "id",
        fields: ['id', 'name', 'desc','gvid','member','owner']
    });
	var vogrid = new Ext.grid.GridPanel({
        store: vostore,
        loadMask: true,
		id:'vogrid',
		border:false,
        columns: [new Ext.grid.CheckboxSelectionModel(), {
            header: "Id",
            width: 30,
            sortable: true,
            dataIndex: 'id'
        }, /*{
            header: "Name",
            width: 60,
            sortable: true,
            dataIndex: 'name'
        }, */{
            header: "Name",
            width: 80,
            sortable: true,
            dataIndex: 'name'
        }, {
            header: "Is Memember",
            width: 80,
            sortable: true,
            dataIndex: 'member'
        }, {
            header: "Owner",
            width: 80,
            sortable: true,
            dataIndex: 'owner'
        },{
            header: "Desc",
            width: 300,
            sortable: true,
            dataIndex: 'desc'
        }],
        viewConfig: {
            forceFit: true
        },
        sm: new Ext.grid.RowSelectionModel({
            singleSelect: true
        }),
        //anchor: '100%, 50%',
		width:600,
		height:200,
        frame: true,
        tbar: ['Search: ', ' ', new Ext.app.SearchField({
            store: vostore,
            width: 320
        }),{
            text: 'AddToVO',
            tooltip: 'Add a new Resource to VO',
            //iconCls:'add',
            handler: function(){
                var _record = grid.getSelectionModel().getSelected();
                if (!_record) {
                    Ext.Msg.alert('Warning!', 'Please select a resource');
                    return;
                }
				var _vorecord = vogrid.getSelectionModel().getSelected();
                if (!_vorecord) {
                    Ext.Msg.alert('Warning!', 'Please select a VO');
                    return;
                }
				
				var resid = _record.get("id");
				var resname = _record.get("name");
				var gvid = _vorecord.get("gvid");
				var voname = _vorecord.get("name");
				var body = myWin.el;
				body.mask('Please wait......','x-mask-loading');
				
                Ext.Ajax.request({
                    url: '../model/vo_util.jsp?func=createresreq',
					params:{
						'resid':resid,
						'gvid':gvid
					},
                    success: function(response){
						body.unmask(false);
						var result = eval("("+response.responseText+")");
						if(result.success){
							Ext.Msg.alert('Warning!', 'Successfully create request:add resource '+resname+" to VO "+voname);
						}else{
							Ext.Msg.alert('Warning!', 'Failed to create a vo resource request:' + result.errors.reason);
						}
                    },
                    failure: function(responseObject){
						body.unmask(false);
                        Ext.Msg.alert('Warning!', 'Failed to delete a rca:' + responseObject);
                    }
                });
            }
        }, {
            text: 'Refresh',
            tooltip: 'Refresh',
            handler: function(){
                vostore.load();
                //grid.render();
            }
        }]
    });

    
	var myWin = new Ext.FormPanel({
        width: 600,
        height: 400,
        minWidth: 300,
        minHeight: 200,
        plain: true,
        title: 'Managing RCA Resources',
        layout: 'form',
        border: true,
        //closeAction: 'hide',
        //closable: true,
        items: [grid,vogrid],
        applyTo: 'form-ct'
    });
	
	var p = new Ext.Panel({
        title: 'Help Hints',
        shadown: true,
        collapsible: true,
        renderTo: 'hint',
        width: 200,
		title:'Add Resources to RCA',
        html: '&nbsp;<p>&nbsp;&nbsp;Add Resources to RCAs and send resource joining requests to VOs &nbsp;<p>&nbsp;&nbsp;'
    });
	
	//var gridEl = Ext.getCmp('rcagrid').el;
	//gridEl.mask('Please wait......','x-mask-loading');
	
    // trigger the data store load
    store.load({callback:function(){
		//gridEl.unmask(false);
	}});
	vostore.load();
});
