/*
Copyright (c) 2008 Institute of Computing Technology of Chinese Academy of Sciences, Science and Technology Facilities Council, and Xlab d.o.o.
All rights reserved.

This file is part of VOM. VOM is part of XtreemOS, a Linux-based Grid Operating System, see <http://www.xtreemos.eu> for more details. The XtreemOS project has been developed with the financial support of the European Commission's IST program under contract #FP6-033576.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the XtreemOS project nor the names of its partners and/or contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
Ext.onReady(function(){
    Ext.QuickTips.init();
    
    function checkSubmited(){
        var name = Ext.getCmp('voname');
        if (!name.el.dom.value == null || name.el.dom.value.length <= 0) {
            Ext.MessageBox.alert("Create A VO", "vo name is null");
            name.focus();
            return false;
        }
        
        return true;
    }
    
    var fs = new Ext.FormPanel({
    	width: 640,
    	title: 'Create a VO',
        labelWidth: 70,
        bodyStyle: 'padding:15px',
        border: false,
        frame: true,
        waitMsgTarget: true,
         monitorValid:true,
        url: '../model/vo_owned.jsp',
        items: [{
            layout: 'column',
            items: [{
                columnWidth: .7,
                layout: 'form',
                items: [{
                    xtype: 'textfield',
                    fieldLabel: 'VO Name',
                    name: 'voname',
                    id: 'voname',
                    anchor: '95%',
                    allowBlank: false
                }, {
                
                    xtype: "checkbox",
                    fieldLabel: "Options",
                    boxLabel: "Automatic approving of requests(disabled)",
                    name: "autoapprove",
                    id: "autoapprove",
                    inputValue: "cbvalue",
                	disabled: true
                }]
            }]
        }, {
            xtype: 'htmleditor',
            id: 'desc',
            fieldLabel: 'VO Description',
            height: 120,
            anchor: '98%'
        }],
        
        buttons: [{
            text: 'Create',
            handler: function(){
                if (!checkSubmited()) 
                    return false;
                var form = fs.getForm();
                var node_id = Ext.getCmp('autoapprove');
                node_id.el.dom.value = node_id.checked;
                var voname = Ext.getCmp('voname').el.dom.value;
                
                form.submit({
                    waitTitle: 'Connecting',
                    waitMsg: 'Waiting...',
                    success: function(form, action){
                        Ext.Msg.alert('Create a VO', "Successfully create a vo:!" + voname);
                        /*
                        form.reset();
                        myWin.close();
                        if (store != null) {
                            store.load();
                        }
                        */
                        var redirect = 'uni_view.jsp?module=user&js=null'; 
		            	window.location = redirect;
                    },
                    failure: function(form, action){
                        if (action.failureType == 'server') {
                            obj = Ext.util.JSON.decode(action.response.responseText);
                            Ext.Msg.alert('Server Failed!', obj.errors.reason);
                        }
                        else {
                            Ext.Msg.alert('Warning!', 'Server is unreachable:' + action.response.responseText);
                        }
                        myWin.close();
                    }
                });
            }
        }, {
            text: 'Cancel',
            handler: function(){
                myWin.close();
            }
        }]
    });
    
    fs.render('form-ct');
    
    var p = new Ext.Panel({
        title: 'Help Hints',
        shadown: true,
        collapsible:true,
        renderTo: 'hint',
        width:150,
        html: '<p>&nbsp;<p>&nbsp;After the creation, you naturally become the owner & user of this vo, i.e. you could get your XOS-Cert. <p>&nbsp;'
    });  
});

