/*
Copyright (c) 2008 Institute of Computing Technology of Chinese Academy of Sciences, Science and Technology Facilities Council, and Xlab d.o.o.
All rights reserved.

This file is part of VOM. VOM is part of XtreemOS, a Linux-based Grid Operating System, see <http://www.xtreemos.eu> for more details. The XtreemOS project has been developed with the financial support of the European Commission's IST program under contract #FP6-033576.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the XtreemOS project nor the names of its partners and/or contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
Ext.onReady(function(){
    Ext.QuickTips.init();
    Ext.form.Field.prototype.msgTarget = 'side';
    
    var frm_width = 320;
    var fld_width = 130;
    var fs = new Ext.form.FormPanel({
        id: 'formanchor-form',
        labelWidth: 70,
        bodyStyle: 'padding:15px',
        border: false,
        frame: true,
        waitMsgTarget: true,
        url: '../model/user_gen_keypair.jsp',
        title: 'Generate new keypair (private key)',
        width: 500,
        layout: 'form',
        items: [{
	    layout:'form',
            items: [{
                //html:'<a href="../model/send_userkey.jsp">Download your current private key file</a><p>&nbsp;'
                html: '<div><p>You can download the current private key file:<button id="mb-download">Download</button></p></div>'
		,height:30
            }, {
                //html:'<a href="../model/send_userkey.jsp">Download your current private key file</a><p>&nbsp;'
                html: '<div id="privKey">You can generate new private key file:<button id="mb1-gen">Generate</button><div id=\'privekey-div\'></div></div>'
		,height:150
            }]
        } ]
    });
    
    fs.render('form-ct');
    var download = Ext.get('mb-download');
    download.on('click', function(){
        window.open('../model/send_userkey.jsp', 'test');
    });
    var gen = Ext.get('mb1-gen');
    gen.on('click', function(){
        gen.value = '';
	gen.dom.disabled=true;
        var parentEl = Ext.get('privekey-div');
        var dialog = new Ext.form.FieldSet({
            title: 'Specify generating parameters:',
            autoHeight: true,
            defaultType: 'textfield',
            renderTo: parentEl,
            id: 'gen-dialog',
            items: [{
                fieldLabel: 'Passphrase',
                name: 'pwd',
                inputType: 'password',
                width: fld_width,
                allowBlank: false
            }, {
                fieldLabel: 'Retype-Pass',
                name: 'rpwd',
                inputType: 'password',
                width: fld_width,
                allowBlank: false
            }],
            buttons: [{
                text: 'Submit',
                formBind: true,
                scope: this,
                handler: function(){
                    fs.getForm().submit({
                        waitTitle: 'Connecting',
                        waitMsg: 'Sending data...',
                        success: function(){
                            Ext.Msg.alert('Status', 'Generating Keypair Successful!', function(btn, text){
                            });
                            parentEl.slideOut('b', {
                                //callback: clearRunning,
                                duration: .35
                            });
                            Ext.get('gen-dialog').remove();
			    gen.dom.disabled=false;
                        },
                        failure: function(form, action){
                            if (action.failureType == 'server') {
                                obj = Ext.util.JSON.decode(action.response.responseText);
                                Ext.Msg.alert('Generating Keypair Failed!', obj.errors.reason);
                            }
                            else {
                                Ext.Msg.alert('Warning!', 'Authentication server is unreachable:' + action.response.responseText);
                            }
                        }
                    });
                }//end handler
            }, {
                text: 'Hide',
                scope: this,
                formBind: true,
                handler: function(){
                    parentEl.slideOut('b', {
                        //callback: clearRunning,
                        duration: .35
                    });
                    Ext.get('gen-dialog').remove();
		    gen.dom.disabled=false;
                }
            }]
        });
        parentEl.slideIn('t', {
            //callback: clearRunning,
            duration: .35
        });
    });
    var p = new Ext.Panel({
        title: 'Help Hints',
        shadown: true,
        collapsible: true,
        renderTo: 'hint',
        width: 200,
        html: '&nbsp;<p>&nbsp;&nbsp;Warning: generate a new private key pair will make your past XOS-Certs not functional &nbsp;<p>&nbsp;&nbsp;'
    });
    
});

