/*
Copyright (c) 2008 Institute of Computing Technology of Chinese Academy of Sciences, Science and Technology Facilities Council, and Xlab d.o.o.
All rights reserved.

This file is part of VOM. VOM is part of XtreemOS, a Linux-based Grid Operating System, see <http://www.xtreemos.eu> for more details. The XtreemOS project has been developed with the financial support of the European Commission's IST program under contract #FP6-033576.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the XtreemOS project nor the names of its partners and/or contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
Ext.onReady(function(){
    Ext.QuickTips.init();
    Ext.form.Field.prototype.msgTarget = 'side';
    /*
    var store = new Ext.data.SimpleStore({
        fields: ['name', 'description', 'creator'],
        data : Xtreemos.data.mockvos 
    });
	*/
	var store = new Ext.data.JsonStore({
        url: "../model/list_vo.jsp",
        totalProperty: "results",
        root: "rows",
        fields: ['id','name','owner','desc','gvid','member']
    });
	
    var frm_width = 320;
    var fld_width = 130;
    var fs = new Ext.form.FormPanel({
    		id:'formanchor-form'
        ,labelWidth:70
			  ,bodyStyle:'padding:15px'
			  ,border:false
				,frame:true,
        waitMsgTarget: true,
        url:'../model/user_get_xoscert.jsp', 
        title: 'Get an XOS-Cert',
        width: 500,
        items: [
            new Ext.form.FieldSet({
                title: 'Choose your joined VO:',
                autoHeight: true,
                defaultType: 'textfield',
                items: [
                new Ext.form.ComboBox({
                		id:'voname',
                        store: store,
                        name: 'name',
                        displayField:'name',
                        typeAhead: true,
                        mode: 'local',
                        triggerAction: 'all',
                        emptyText:'Select a VO...',
                        selectOnFocus:true,
                        fieldLabel: 'VO Name',
                        width:fld_width
                        // applyTo: 'local-states'
                    })
                ]
            }),
            new Ext.form.FieldSet({
                title: 'Specify Cert generating parameters:',
                autoHeight: true,
                defaultType: 'textfield',
                items: [
                /*
                {
                    fieldLabel: 'Login id',
                    name: 'uid',
                    width:fld_width,
                    allowBlank: false
                }, */
                {
                    fieldLabel:'Passphrase', 
                    name:'pwd', 
                    inputType:'password', 
                    width:fld_width,
                    allowBlank:false 
                },
                /*{
                    fieldLabel:'Retype-Pass', 
                    name:'rpwd', 
                    inputType:'password', 
                    width:fld_width,
                    allowBlank:false 
                },*/
                {
                    fieldLabel:'Valid days', 
                    name:'days', 
                    width:fld_width,
                    allowBlank:false 
                }
                /*
                new Ext.form.DateField({
                    fieldLabel: 'Expire date',
                    name: 'dob',
                    width:fld_width,
                    allowBlank:false
                }) */

                ]
            })
        ],
        buttons:[{
					text:'Submit'
					,formBind:true
					,scope:this
				  ,handler:function(){
            fs.getForm().submit({
                waitTitle:'Connecting',
                waitMsg:'Sending data...',
                success:function(){
                    Ext.Msg.alert('Status', 'Creating XOS-Cert Successful! <br><a href="../model/send_cert.jsp?vo=' + Ext.getCmp('voname').value + '">Download the generated XOS-Cert</a>', function(btn, text){
				        if (btn == 'ok'){
		                    // var redirect = 'index.jsp'; 
		                   //  window.location = redirect;
                        }
			        });
                },
                failure:function(form, action){ 
                    if(action.failureType == 'server'){ 
                        obj = Ext.util.JSON.decode(action.response.responseText); 
                        Ext.Msg.alert('Creating XOS-Cert Failed!', obj.errors.reason); 
                    }else{ 
                        Ext.Msg.alert('Warning!', 'Authentication server is unreachable:'+ action.response.responseText); 
                    } 
                }
            });
        	}//end handler
				}]				
    });

    /*var submit = fs.addButton({
        text: 'Submit',
        formBind: true,
        handler: function(){
            fs.getForm().submit({
                waitTitle:'Connecting',
                waitMsg:'Sending data...',
                success:function(){
                    Ext.Msg.alert('Status', 'SignIn Successful!', function(btn, text){
				        if (btn == 'ok'){
		                    var redirect = 'index.jsp'; 
		                    window.location = redirect;
                        }
			        });
                },
                failure:function(form, action){ 
                    if(action.failureType == 'server'){ 
                        obj = Ext.util.JSON.decode(action.response.responseText); 
                        Ext.Msg.alert('Login Failed!', obj.errors.reason); 
                    }else{ 
                        Ext.Msg.alert('Warning!', 'Authentication server is unreachable:'+ action.response.responseText); 
                    } 
                }
            });
        }
    });*/

    fs.render('form-ct');
    store.load();
    /*
    var win = new Ext.Window({
					id:'formanchor-win'
					,width:560
					,height:400
					,minWidth:300
					,minHeight:200
					,plain:true
					,title:'Get a XOS Cert'
				  ,layout:'fit'
				 ,border:false
				 ,closable:true
			   ,items:fs
			   ,rendTo: 'form-ct'
		 });
		 win.show();
		*/ 
    
    var p = new Ext.Panel({
        title: 'Help Hints',
        shadown: true,
        collapsible:true,
        renderTo: 'hint',
        width:200,
        html: ' &nbsp;<p>&nbsp;&nbsp;Please specify the passphrase for your private key, if the private key does not exists, it will be automatically created.&nbsp;<p>&nbsp;&nbsp; '
    });
    
});

