/*
Copyright (c) 2008 Institute of Computing Technology of Chinese Academy of Sciences, Science and Technology Facilities Council, and Xlab d.o.o.
All rights reserved.

This file is part of VOM. VOM is part of XtreemOS, a Linux-based Grid Operating System, see <http://www.xtreemos.eu> for more details. The XtreemOS project has been developed with the financial support of the European Commission's IST program under contract #FP6-033576.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the XtreemOS project nor the names of its partners and/or contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
Ext.onReady(function(){
    Ext.QuickTips.init();

	var store = new Ext.data.JsonStore({
        url: "../model/list_requests.jsp",
        totalProperty: "results",
        root: "rows",
        fields: ['id','type','vo']
    });
	
    var grid = new Ext.grid.GridPanel({
    	applyTo: 'form-ct',
        store: store,
        loadMask: true,
	id:'vogrid',
	title: 'My Pending Requests',
	width: 400,
	height: 400,
	autoScroll:true,
       
        columns: [new Ext.grid.CheckboxSelectionModel(), {
            header: "ID",
            width: 25,
            sortable: true,
            dataIndex: 'id'
        }, {
            header: "Type",
            width: 50,
            sortable: true,
            dataIndex: 'type'
        }, {
            header: "VO Name",
            width: 50,
            sortable: true,
            dataIndex: 'vo'
        }],
        viewConfig: {
            forceFit: true
        },
        sm: new Ext.grid.RowSelectionModel({
		singleSelect: true,
		listeners:{
			rowselect :function(selectionModel){
				if(!selectionModel){
					return ;
				}
				var _record = selectionModel.getSelected();
				if (!_record) {
					return;
				}
			}	
		}
        }),
        frame: true
   });
	
   grid.getSelectionModel();
   store.load();

   var p = new Ext.Panel({
	   title: 'Help Hints',
	   shadown: true,
	   collapsible:true,
	   renderTo: 'hint',
	   width:250,
	   html: '<p>&nbsp;<p>&nbsp;Here is a list of all of your requests (user joining or resource joining requests)<p>&nbsp;'
    });
});

