/*
Copyright (c) 2008 Institute of Computing Technology of Chinese Academy of Sciences, Science and Technology Facilities Council, and Xlab d.o.o.
All rights reserved.

This file is part of VOM. VOM is part of XtreemOS, a Linux-based Grid Operating System, see <http://www.xtreemos.eu> for more details. The XtreemOS project has been developed with the financial support of the European Commission's IST program under contract #FP6-033576.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the XtreemOS project nor the names of its partners and/or contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
Ext.onReady(function(){
    Ext.QuickTips.init();
    
    function checkSubmited(){
        return true;
    }
    
    
    var store = new Ext.data.JsonStore({
        url: "../model/list_users.jsp",
        totalProperty: "results",
        root: "rows",
        id: "id",
        fields: ['guid', 'username']
    });
    
    function getVoNode(node){
        if (node == null) 
            return null;
        if (node.parentNode == treeRoot) 
            return node;
        
        var lastnode = node;
        while (node != treeRoot) {
            lastnode = node;
            node = node.parentNode;
        }
        return lastnode;
    }
    
    var updateNodeGrid = function(node){
        var type = node.attributes.type;
        var url = "";
        var para = null;
        var parent = null;
        var voparent = null;
        var voParentNode = getVoNode(node);
        if (type == "vo") {
            para = node.text;
        }
        else if (type == "group") {
		para = node.text;
                parent = node.parentNode.text;
        }else if (type == "role") {
		para = node.text;
		parent = node.parentNode.text;
                voparent = voParentNode.text;
	}
        gridstore.load({
            params: {
                'type': type,
                'para': para,
                'parent': parent,
                'voParent': voparent
            }
        });
    };
    
    function refreshNode(node){
        if (node == null) 
            return;
        var treeLoader = tree.getLoader();
        treeLoader.load(node);
        node.expand();
        updateNodeGrid(node);
    }
    var ctxMenu = new Ext.menu.Menu({
        id: 'ctxMenu',
        items: [{
            id: 'addg',
            handler: function(){
                var msgDlg = Ext.Msg.prompt('Group Name', 'Please enter group name:', function(btn, text){
                    if (btn == 'ok') {
			if(text.length < 1) return;
                        var myTree = Ext.getCmp('ext_tree');
                        var node = myTree.getSelectionModel().getSelectedNode();
                        var testStr = node.text;
                        var myWin = Ext.getCmp("manGroups");
                        var body = myWin.el;
                        body.mask('Please wait......', 'x-mask-loading');
                        Ext.Ajax.request({
                            url: '../model/vo_addop.jsp?type=vo&oper=group',
                            params: {
                                'para': testStr,
                                'name': text
                            },
                            success: function(response){
                                body.unmask(false);
                                var result = eval("(" + response.responseText + ")");
                                if (result.success) {
                                    Ext.Msg.alert('Congratulations!', 'Successfully Add a Group ' + text);
                                    refreshNode(node);
                                }
                                else {
                                    Ext.Msg.alert('Sorry!', 'Failed to Add a Group ' + text + ':' + result.errors.reason);
                                }
                            },
                            failure: function(responseObject){
                                body.unmask(false);
                                Ext.Msg.alert('Sorry!', 'Failed to Add a Group:' + responseObject);
                            }
                        });
                    }
                });
            },
            text: 'AddGroup'
        }, {
            id: 'addr',
            handler: function(node){
                var msgDlg = Ext.Msg.prompt('Role Name', 'Please enter role name:', function(btn, text){
                    if (btn == 'ok') {
			if(text.length < 1) return;
                        var myTree = Ext.getCmp('ext_tree');
                        var node = myTree.getSelectionModel().getSelectedNode();
                        var testStr = node.text;
                        var testpStr = node.parentNode.text;
                        var myWin = Ext.getCmp("manGroups");
                        var body = myWin.el;
                        body.mask('Please wait......', 'x-mask-loading');
                        Ext.Ajax.request({
                            url: '../model/vo_addop.jsp?type=group&oper=role',
                            params: {
                                'para': testStr,
                                'name': text,
                                'parent': testpStr
                            },
                            success: function(response){
                                body.unmask(false);
                                var result = eval("(" + response.responseText + ")");
                                if (result.success) {
                                    Ext.Msg.alert('Congratulations!', 'Successfully Add a Role ' + text);
                                    refreshNode(node);
                                }
                                else {
                                    Ext.Msg.alert('Congratulations!', 'Failed to Add a Role ' + text + ':' + result.errors.reason);
                                }
                            },
                            failure: function(responseObject){
                                body.unmask(false);
                                Ext.Msg.alert('Congratulations!', 'Failed to Add a Role:' + responseObject);
                            }
                        });
                        }
                });
            },
            text: 'AddRole'
        }, {
            id: 'addu',
            handler: function(){
                var url = "";
                var prefix = '../model/vo_addop.jsp';
                var myTree = Ext.getCmp('ext_tree');
                var node = myTree.getSelectionModel().getSelectedNode();
                var text = node.text;
                var type = node.attributes.type;
                var para = null;
                var parent = null;
                var voParent = null;
                var voParentNode = getVoNode(node.parentNode);
                if (type == "vo") {
                    url = prefix + "?type=vo&oper=user&para=" + text;
                    para = text;
                }
                else 
                    if (type == "group") {
                        parent = node.parentNode.text;
                        para = text;
                        url = prefix + "?type=group&oper=user&para=" + text + "&parent=" + parent;
                    }
                    else 
                        if (type == "role") {
                            parent = node.parentNode.text;
                            para = text;
                            if (voParentNode != null) 
                                voParent = voParentNode.text;
                            url = prefix + "?type=role&oper=user&para=" + text + "&parent=" + parent + "&voParent=" +
                            voParent;
                        }
                store.load({
                    params: {
                        'type': 'vo',
                        'para': voParentNode.text
                        //'voParent':voParent,
                        //'parent':parent
                    }
                });
                //alert(url);			
                var fs = new Ext.form.FormPanel({
                    //var anotherWin = new Ext.Window({
                    id: 'formp',
                    labelWidth: 70,
                    bodyStyle: 'padding:15px',
                    border: false,
                    frame: true,
                    waitMsgTarget: true,
                    url: url,
                    width: 250,
                    //title:'Add a User to Group/Role',
                    layout: 'fit',
                    items: [                    /*new Ext.form.FieldSet({
                     title: 'Choose a user:',
                     autoHeight: true,
                     defaultType: 'textfield',
                     items: [*/
                    new Ext.form.ComboBox({
                        store: store,
                        displayField: 'username',
                        valueField: 'username',
                        typeAhead: true,
                        mode: 'local',
                        id: 'name',
                        name: 'name',
                        triggerAction: 'all',
                        emptyText: 'Select a User...',
                        selectOnFocus: true,
                        fieldLabel: 'User'
                        //width: 150
                    }) //],						
                    //})
                    ],
                    buttons: [{
                        text: 'Submit',
                        formBind: true,
                        scope: this,
                        handler: function(){
                            var form = fs.getForm();
                            var node_id = Ext.getCmp('name');
                            form.submit({
                                waitTitle: 'Add a user',
                                waitMsg: 'Waiting...',
                                success: function(form, action){
                                    form.reset();
                                    var result = eval("(" + action.response.responseText + ")");//parseInt(action.response.responseText);
                                    if (result.success) {
                                        Ext.Msg.alert("Add user!", "Add user success!");
                                        store.load();
                                        refreshNode(node);
                                    }
                                    else {
                                        Ext.Msg.alert("Add user", "Add user failure!:" + result.errors.reason);
                                    }
                                    anotherWin.close();
                                },
                                failure: function(form, action){
                                    //Ext.Msg.alert(action.response.responseText);
                                    anotherWin.close();
                                }
                            });
                        }//end handler
                    }]
                });
                
                var anotherWin = new Ext.Window({
                    id: "awid",
                    width: 250,
                    height: 150,
                    minWidth: 300,
                    minHeight: 160,
                    plain: true,
                    title: 'Select User',
                    layout: 'fit',
                    border: false,
                    closeAction: 'hide',
                    closable: true,
                    items: fs,
                    rendTo: 'form-ct'
                });
                anotherWin.show();
                //store.load();
            },
            text: 'AddUser'
        }, {
            id: 'refresh',
            handler: function(){
                var myTree = Ext.getCmp('ext_tree');
                var node = myTree.getSelectionModel().getSelectedNode();
                if (node.isLeaf()) 
                    return;
                var treeLoader = myTree.getLoader();
                treeLoader.load(node);
                node.expand();
            },
            text: 'Refresh'
        }]
    });
    var rootId = "root";
    var tree = new Ext.tree.TreePanel({
        id: 'ext_tree',
        region: 'west',
        split: true,
        width: 180,
        minSize: 95,
        maxSize: 500,
        collapsible: true,
        margins: '0 0 5 5',
        cmargins: '0 0 0 0',
        lines: false,
        autoScroll: true,
        animCollapse: false,
        animate: false,
        collapseMode: 'mini',
        border: false,
        rootVisible: false,
        animate: true,
        enableDD: true,
        containerScroll: true,
        loader: new Ext.tree.TreeLoader({
            dataUrl: '../model/vo_groupnodes.jsp'
        })
    });
    var treeRoot = new Ext.tree.AsyncTreeNode({
        text: 'AllVOs',
        draggable: false,
        id: 'root'
    });
    
    tree.setRootNode(treeRoot);
    var gridstore = new Ext.data.JsonStore({
        url: '../model/list_users.jsp',
        totalProperty: "results",
        root: "rows",
        id: "id",
        fields: ['username', 'email', 'guid', 'affiliation', 'realname', 'id']
    });
    
    var treeWindow = new Ext.Panel({
        border: true,
        id: 'manGroups',
        applyTo: 'form-ct',
        //id:'treeWindow',
        title: 'Managing groups/roles',
        width: 600,
        height: 400,
        layout: 'border',
        items: [tree, {
            region: 'center',
            id: 'textarea-container',
            margins: '0 5 5 0',
            resizeTabs: true,
            border: false,
            layout: 'fit',
            //items: [{
            xtype: 'grid',
            store: gridstore,
            loadMask: true,
            //id: 'rcagrid',
            columns: [{
                header: "Id",
                width: 30,
                sortable: true,
                dataIndex: 'id'
            }, {
                header: "Name",
                width: 120,
                sortable: true,
                dataIndex: 'username'
            }, {
                header: "Realname",
                width: 120,
                sortable: true,
                dataIndex: 'realname'
            }, {
                header: "Affiliation",
                width: 120,
                sortable: true,
                dataIndex: 'affiliation'
            }, {
                header: "Email",
                width: 120,
                sortable: true,
                dataIndex: 'email'
            }],
            viewConfig: {
                forceFit: true
            }
            //frame: true,
            //}],
        }]
    });
    
    tree.on({
        'click': {
            fn: updateNodeGrid
        },
        'contextmenu': {
            fn: function(node, e){
                node.select();
                ctxMenu.items.get('addg')[node.attributes.type == 'vo' ? 'enable' : 'disable']();
                ctxMenu.items.get('addr')[node.attributes.type == 'group' ? 'enable' : 'disable']();
                ctxMenu.items.get('addu')[node.attributes.type != 'vo' ? 'enable' : 'disable']();
                ;
                //ctxMenu.items.get('delete')[node.attributes.leaf ? 'enable' : 'disable']();
                ctxMenu.items.get('refresh')[node.attributes.leaf ? 'disable' : 'enable']();
                var xy = e.getXY(), menuHeight = ctxMenu.getEl().getHeight();
                ctxMenu.showAt(xy);
            }
        },
        'beforeexpandnode': {
            fn: function(node){
                //alert("before expand node!");
                //var url = 'groupNodes.jsp?nodeId=' + (node.id!='root'?"root":"other");
                //alert(url);
                //user_tree.loader.dataUrl = url;
                //var myLoader = new Ext.tree.TreeLoader({dataUrl:'groupNodes.jsp?'});
                //myLoader.baseParams.extra = node.attributes.type;
                //myLoader.baseParams.parent = (node.attributes.type == 'group'? node.parent.id:"");
                //var url = 'groupNodes.jsp?extra=vo';
                //user_tree.loader.dataUrl = url;
            }
        }
    });
    
    var p = new Ext.Panel({
        title: 'Help Hints',
        shadown: true,
        collapsible: true,
        renderTo: 'hint',
        width: 200,
        html: '&nbsp;<p>&nbsp;&nbsp;Click VO,Group or Role names to list users belong to them, Right Click VO,Group,Role to add their subitems or users &nbsp;<p>&nbsp;&nbsp;'
    });
    
    tree.render();
    treeRoot.expand();
    treeWindow.show();
    
});

